
DROP TRIGGER IF EXISTS sk_card_serie_del ON sk_card_series CASCADE;
DROP TRIGGER IF EXISTS sk_rad_user_add_tg ON sk_users CASCADE;
DROP TRIGGER IF EXISTS sk_rad_user_upd_tg ON sk_users CASCADE;
DROP TRIGGER IF EXISTS sk_rad_user_del_tg ON sk_users CASCADE;
DROP TRIGGER IF EXISTS sk_rad_group_add_tg ON sk_packets CASCADE;
DROP TRIGGER IF EXISTS sk_rad_group_upd_tg ON sk_packets CASCADE;
DROP TRIGGER IF EXISTS sk_rad_group_del_tg ON sk_packets CASCADE;
DROP TRIGGER IF EXISTS sk_rad_price_trigger ON sk_prices CASCADE;
DROP TRIGGER IF EXISTS sk_acc_upd_tg ON sk_accounts CASCADE;

CREATE OR REPLACE FUNCTION sk_card_serie_del()
RETURNS "trigger" AS '
BEGIN
DELETE FROM sk_card_data WHERE sk_card_data.sid=OLD.sid;
DELETE FROM sk_users WHERE sk_users.sid=OLD.sid;
RETURN OLD;
END;
'
  LANGUAGE 'plpgsql' VOLATILE;


CREATE OR REPLACE FUNCTION sk_rad_user_add()
RETURNS trigger AS '
DECLARE pack_row sk_packets%ROWTYPE;
	serv_id int8;
BEGIN
	IF ( new.gid != 0) THEN
		SELECT * INTO pack_row FROM sk_packets WHERE sk_packets.gid=new.gid;
		IF (new.deposit IS NULL) THEN
			new.deposit := 0;
		END IF;
		IF (new.credit IS NULL OR new.credit=0) THEN
			new.credit := pack_row.credit;
		END IF;
		IF (new.tos IS NULL OR new.tos=0) THEN
			new.tos := pack_row.tos;
		END IF;
		IF (new.do_with_tos IS NULL OR new.do_with_tos=0) THEN
			new.do_with_tos := pack_row.do_with_tos;
		END IF;
		IF (new.direction IS NULL OR new.direction=0) THEN
			new.direction := pack_row.direction;
		END IF;
		IF (new.fixed IS NULL OR new.fixed=0) THEN
			new.fixed := pack_row.fixed;
		END IF;
		IF (new.fixed_cost IS NULL OR new.fixed_cost=0) THEN
			new.fixed_cost := pack_row.fixed_cost;
		END IF;
		IF (new.activation_time IS NULL OR new.activation_time=0) THEN
			new.activation_time := pack_row.activation_time;
		END IF;
		IF (new.total_time_limit IS NULL OR new.total_time_limit=0) THEN
			new.total_time_limit := pack_row.total_time_limit;
		END IF;
		IF (new.total_traffic_limit IS NULL OR new.total_traffic_limit=0) THEN
			new.total_traffic_limit := pack_row.total_traffic_limit;
		END IF;
		IF (new.total_money_limit IS NULL OR new.total_money_limit=0) THEN
			new.total_money_limit := pack_row.total_money_limit;
		END IF;
		IF (new.month_time_limit IS NULL OR new.month_time_limit=0) THEN
			new.month_time_limit := pack_row.month_time_limit;
		END IF;
		IF (new.month_traffic_limit IS NULL OR new.month_traffic_limit=0) THEN
			new.month_traffic_limit := pack_row.month_traffic_limit;
		END IF;
		IF (new.month_money_limit IS NULL OR new.month_money_limit=0) THEN
			new.month_money_limit := pack_row.month_money_limit;
		END IF;
		IF (new.week_time_limit IS NULL OR new.week_time_limit=0) THEN
			new.week_time_limit := pack_row.week_time_limit;
		END IF;
		IF (new.week_traffic_limit IS NULL OR new.week_traffic_limit=0) THEN
			new.week_traffic_limit := pack_row.week_traffic_limit;
		END IF;
		IF (new.week_money_limit IS NULL OR new.week_money_limit=0) THEN
			new.week_money_limit := pack_row.week_money_limit;
		END IF;
		IF (new.day_time_limit IS NULL OR new.day_time_limit=0) THEN
			new.day_time_limit := pack_row.day_time_limit;
		END IF;
		IF (new.day_traffic_limit IS NULL OR new.day_traffic_limit=0) THEN
			new.day_traffic_limit := pack_row.day_traffic_limit;
		END IF;
		IF (new.day_money_limit IS NULL OR new.day_money_limit=0) THEN
			new.day_money_limit := pack_row.day_money_limit;
		END IF;
		IF (new.simultaneous_use IS NULL OR new.simultaneous_use=0) THEN
			new.simultaneous_use := pack_row.simultaneous_use;
		END IF;
		IF (new.port_limit IS NULL OR new.port_limit=0) THEN
			new.port_limit := pack_row.port_limit;
		END IF;
		IF (new.session_timeout IS NULL OR new.session_timeout=0) THEN
			new.session_timeout := pack_row.session_timeout;
		END IF;
		IF (new.idle_timeout IS NULL OR new.idle_timeout=0) THEN
			new.idle_timeout := pack_row.idle_timeout;
		END IF;
		IF (new.no_pass IS NULL OR new.no_pass=0) THEN
			new.no_pass := pack_row.no_pass;
		END IF;
		IF (new.no_acct IS NULL OR new.no_acct=0) THEN
			new.no_acct := pack_row.no_acct;
		END IF;
		IF (new.allow_callback IS NULL OR new.allow_callback=0) THEN
			new.allow_callback := pack_row.allow_callback;
		END IF;
		IF (new.blocked IS NULL OR new.blocked=0) THEN
			new.blocked := pack_row.blocked;
		END IF;
		IF (new.activated IS NULL OR new.activated=0) THEN
			new.activated := pack_row.activated;
		END IF;
		IF (new.up IS NULL OR new.up=0) THEN
			new.up := pack_row.up;
		END IF;
		IF (new.down IS NULL OR new.down=0) THEN
			new.down := pack_row.down;
		END IF;
		IF (new.login_time IS NULL OR new.login_time='''') THEN
			new.login_time := pack_row.login_time;
		END IF;
		IF (new.huntgroup_name IS NULL OR new.huntgroup_name='''') THEN
			new.huntgroup_name := pack_row.huntgroup_name;
		END IF;
		IF (new.other_params IS NULL OR new.other_params='''') THEN
			new.other_params := pack_row.other_params;
		END IF;
		IF (new.allowed_servers IS NULL OR new.allowed_servers='''') THEN
			new.allowed_servers := pack_row.allowed_servers;
		END IF;
		IF (new.framed_ip IS NULL OR new.framed_ip='''') THEN
			new.framed_ip := pack_row.framed_ip;
		END IF;
		IF (new.framed_mask IS NULL OR new.framed_mask='''') THEN
			new.framed_mask := pack_row.framed_mask;
		END IF;
		IF (new.ippool_name IS NULL OR new.ippool_name='''') THEN
			new.ippool_name := pack_row.ippool_name;
		END IF;
		IF (new.framed_route IS NULL OR new.framed_route='''') THEN
			new.framed_route := pack_row.framed_route;
		END IF;

	END IF;
	UPDATE sk_packets SET users_col = users_col + 1 WHERE sk_packets.gid=NEW.gid;
	IF (NEW.sid > 0) THEN
		UPDATE sk_card_series SET cards_col = cards_col + 1 WHERE sk_card_series.sid = NEW.sid;
	END IF;
	IF (new.account_id = 0) THEN
	    INSERT INTO sk_accounts (service_set_id, int_property) VALUES (pack_row.service_set_id, new.uid);
	    SELECT sk_accounts.account_id INTO new.account_id FROM sk_accounts WHERE service_set_id=pack_row.service_set_id AND int_property=new.uid;
	END IF;
	RETURN new;
END;
'  LANGUAGE plpgsql VOLATILE;

CREATE OR REPLACE FUNCTION sk_rad_user_upd()
RETURNS trigger AS '
DECLARE pack_row sk_packets%ROWTYPE;
BEGIN
	IF ( NEW.gid != OLD.gid) THEN
		SELECT * INTO pack_row FROM sk_packets WHERE sk_packets.gid=new.gid;
		IF (new.deposit IS NULL) THEN
			new.deposit := 0;
		END IF;
		new.credit := pack_row.credit;
		new.tos := pack_row.tos;
		new.do_with_tos := pack_row.do_with_tos;
		new.direction := pack_row.direction;
		new.fixed := pack_row.fixed;
		new.fixed_cost := pack_row.fixed_cost;
		new.activation_time := pack_row.activation_time;
		new.total_time_limit := pack_row.total_time_limit;
		new.total_traffic_limit := pack_row.total_traffic_limit;
		new.total_money_limit := pack_row.total_money_limit;
		new.month_time_limit := pack_row.month_time_limit;
		new.month_traffic_limit := pack_row.month_traffic_limit;
		new.month_money_limit := pack_row.month_money_limit;
		new.week_time_limit := pack_row.week_time_limit;
		new.week_traffic_limit := pack_row.week_traffic_limit;
		new.week_money_limit := pack_row.week_money_limit;
		new.day_time_limit := pack_row.day_time_limit;
		new.day_traffic_limit := pack_row.day_traffic_limit;
		new.day_money_limit := pack_row.day_money_limit;
		new.simultaneous_use := pack_row.simultaneous_use;
		new.port_limit := pack_row.port_limit;
		new.session_timeout := pack_row.session_timeout;
		new.idle_timeout := pack_row.idle_timeout;
		new.no_pass := pack_row.no_pass;
		new.no_acct := pack_row.no_acct;
		new.allow_callback := pack_row.allow_callback;
		new.blocked := pack_row.blocked;
		new.activated := pack_row.activated;
		new.up := pack_row.up;
		new.down := pack_row.down;
		new.login_time := pack_row.login_time;
		new.huntgroup_name := pack_row.huntgroup_name;
		new.other_params := pack_row.other_params;
		new.allowed_servers := pack_row.allowed_servers;
		new.framed_ip := pack_row.framed_ip;
		new.framed_mask := pack_row.framed_mask;
		new.ippool_name := pack_row.ippool_name;
		new.framed_route := pack_row.framed_route;

	END IF;
	IF (NEW.tos != OLD.tos) THEN
		DELETE FROM sk_prices WHERE sk_prices.uid=OLD.uid;
	END IF;
	IF (NEW.deposit != OLD.deposit) THEN
		INSERT INTO sk_system_conf (value, attribute) VALUES (''1'', ''internal_account_update'');
		UPDATE sk_accounts SET a_sum=a_sum-(OLD.deposit-NEW.deposit) WHERE sk_accounts.account_id=OLD.account_id;
		DELETE FROM sk_system_conf WHERE attribute=''internal_account_update'';
	END IF;
	UPDATE sk_objects SET nickname=NEW.username, password=NEW.password WHERE sk_objects.mode=''P'' AND sk_objects.nickname=OLD.username AND sk_objects.password=OLD.password;
	RETURN NEW;
END;
'  LANGUAGE plpgsql VOLATILE;

CREATE OR REPLACE FUNCTION sk_rad_user_del()
RETURNS trigger AS '
DECLARE
    old_uid int8;
    old_username varchar(64);
    old_password varchar(64);
    old_gid int8;
    old_sid int8;
BEGIN
    old_uid := OLD.uid;
    old_gid := OLD.gid;
    old_sid := OLD.sid;
    old_username := OLD.username;
    old_password := OLD.password;
    
	DELETE FROM sk_actions WHERE sk_actions.uid=old_uid OR sk_actions.username=old_username;
	DELETE FROM sk_prices WHERE sk_prices.uid=old_uid;
	UPDATE sk_packets SET users_col=users_col-1 WHERE sk_packets.gid=old_gid;
	DELETE FROM sk_accounts WHERE sk_accounts.int_property=old_uid;
	DELETE FROM sk_objects WHERE sk_objects.mode=''P'' AND sk_objects.nickname=old_username AND sk_objects.password=old_password;
	IF (old_sid > 0) THEN
		UPDATE sk_card_series SET cards_col=cards_col-1 WHERE sk_card_series.sid = old_sid;
	END IF;
	RETURN OLD;
END;
'  LANGUAGE plpgsql VOLATILE;


CREATE OR REPLACE FUNCTION sk_rad_group_add()
RETURNS trigger AS '
BEGIN
	INSERT INTO sk_system_conf (attribute, value) VALUES (''radiusd_restart'', ''1'');
	RETURN NEW;
END;
'  LANGUAGE plpgsql VOLATILE;

CREATE OR REPLACE FUNCTION sk_rad_group_upd()
RETURNS trigger AS '
DECLARE
  new_deposit numeric;
  new_credit numeric;
  new_tos int2;
  new_do_with_tos int2;
  new_direction int2;
  new_fixed int2;
  new_fixed_cost numeric;
  new_activation_time int8;
  new_total_time_limit int8;
  new_month_time_limit int8;
  new_week_time_limit int8;
  new_day_time_limit int8;
  new_total_traffic_limit int8;
  new_month_traffic_limit int8;
  new_week_traffic_limit int8;
  new_day_traffic_limit int8;
  new_total_money_limit numeric;
  new_month_money_limit numeric;
  new_week_money_limit numeric;
  new_day_money_limit numeric;
  new_login_time text;
  new_huntgroup_name text;
  new_simultaneous_use int4;
  new_port_limit int2;
  new_session_timeout int8;
  new_idle_timeout int8;
  new_no_pass int2;
  new_no_acct int2;
  new_allow_callback int2;
  new_other_params text;
  new_allowed_servers text;
  new_blocked int2;
  new_framed_ip text;
  new_framed_mask text;
  new_up int4;
  new_down int4;
  new_ippool_name text;

  old_deposit numeric;
  old_credit numeric;
  old_tos int2;
  old_do_with_tos int2;
  old_direction int2;
  old_fixed int2;
  old_fixed_cost numeric;
  old_activation_time int8;
  old_total_time_limit int8;
  old_month_time_limit int8;
  old_week_time_limit int8;
  old_day_time_limit int8;
  old_total_traffic_limit int8;
  old_month_traffic_limit int8;
  old_week_traffic_limit int8;
  old_day_traffic_limit int8;
  old_total_money_limit numeric;
  old_month_money_limit numeric;
  old_week_money_limit numeric;
  old_day_money_limit numeric;
  old_login_time text;
  old_huntgroup_name text;
  old_simultaneous_use int4;
  old_port_limit int2;
  old_session_timeout int8;
  old_idle_timeout int8;
  old_no_pass int2;
  old_no_acct int2;
  old_allow_callback int2;
  old_other_params text;
  old_allowed_servers text;
  old_blocked int2;
  old_framed_ip text;
  old_framed_mask text;
  old_up int4;
  old_down int4;
  old_ippool_name text;
  old_gid int8;

BEGIN
	INSERT INTO sk_system_conf (attribute, value) VALUES (''radiusd_restart'', ''1'');
	IF (new.tos != OLD.tos) THEN
		DELETE FROM sk_prices WHERE sk_prices.gid=OLD.gid;
	END IF;
	new_deposit := NEW.deposit;
	new_credit := NEW.credit;
	new_tos := NEW.tos;
	new_do_with_tos := NEW.do_with_tos;
	new_direction := NEW.direction;
	new_fixed := NEW.fixed;
	new_fixed_cost := NEW.fixed_cost;
	new_activation_time := NEW.activation_time;
	new_total_time_limit := NEW.total_time_limit;
	new_month_time_limit := NEW.month_time_limit;
	new_week_time_limit := NEW.week_time_limit;
	new_day_time_limit := NEW.day_time_limit;
	new_total_traffic_limit := NEW.total_traffic_limit;
	new_month_traffic_limit := NEW.month_traffic_limit;
	new_week_traffic_limit := NEW.week_traffic_limit;
	new_day_traffic_limit := NEW.day_traffic_limit;
	new_total_money_limit := NEW.total_money_limit;
	new_month_money_limit := NEW.month_money_limit;
	new_week_money_limit := NEW.week_money_limit;
	new_day_money_limit := NEW.day_money_limit;
	new_login_time := NEW.login_time;
	new_huntgroup_name := NEW.huntgroup_name;
	new_simultaneous_use := NEW.simultaneous_use;
	new_port_limit := NEW.port_limit;
	new_session_timeout := NEW.session_timeout;
	new_idle_timeout := NEW.idle_timeout;
	new_no_pass := NEW.no_pass;
	new_no_acct := NEW.no_acct;
	new_allow_callback := NEW.allow_callback;
	new_other_params := NEW.other_params;
	new_allowed_servers := NEW.allowed_servers;
	new_blocked := NEW.blocked;
	new_framed_ip := NEW.framed_ip;
	new_framed_mask := NEW.framed_mask;
	new_up := NEW.up;
	new_down := NEW.down;
	new_ippool_name := NEW.ippool_name;
	old_deposit := OLD.deposit;
	old_credit := OLD.credit;
	old_tos := OLD.tos;
	old_do_with_tos := OLD.do_with_tos;
	old_direction := OLD.direction;
	old_fixed := OLD.fixed;
	old_fixed_cost := OLD.fixed_cost;
	old_activation_time := OLD.activation_time;
	old_total_time_limit := OLD.total_time_limit;
	old_month_time_limit := OLD.month_time_limit;
	old_week_time_limit := OLD.week_time_limit;
	old_day_time_limit := OLD.day_time_limit;
	old_total_traffic_limit := OLD.total_traffic_limit;
	old_month_traffic_limit := OLD.month_traffic_limit;
	old_week_traffic_limit := OLD.week_traffic_limit;
	old_day_traffic_limit := OLD.day_traffic_limit;
	old_total_money_limit := OLD.total_money_limit;
	old_month_money_limit := OLD.month_money_limit;
	old_week_money_limit := OLD.week_money_limit;
	old_day_money_limit := OLD.day_money_limit;
	old_login_time := OLD.login_time;
	old_huntgroup_name := OLD.huntgroup_name;
	old_simultaneous_use := OLD.simultaneous_use;
	old_port_limit := OLD.port_limit;
	old_session_timeout := OLD.session_timeout;
	old_idle_timeout := OLD.idle_timeout;
	old_no_pass := OLD.no_pass;
	old_no_acct := OLD.no_acct;
	old_allow_callback := OLD.allow_callback;
	old_other_params := OLD.other_params;
	old_allowed_servers := OLD.allowed_servers;
	old_blocked := OLD.blocked;
	old_framed_ip := OLD.framed_ip;
	old_framed_mask := OLD.framed_mask;
	old_up := OLD.up;
	old_down := OLD.down;
	old_ippool_name := OLD.ippool_name;
	old_gid := OLD.gid;

	UPDATE sk_users SET 
	deposit=new_deposit, credit=new_credit,
	tos=new_tos, do_with_tos=new_do_with_tos,
	direction=new_direction, fixed=new_fixed,
	fixed_cost=new_fixed_cost, activation_time=new_activation_time,
	total_time_limit=new_total_time_limit, month_time_limit=new_month_time_limit,
	week_time_limit=new_week_time_limit, day_time_limit=new_day_time_limit,
	total_traffic_limit=new_total_traffic_limit, month_traffic_limit=new_month_traffic_limit,
	week_traffic_limit=new_week_traffic_limit, day_traffic_limit=new_day_traffic_limit,
	total_money_limit=new_total_money_limit, month_money_limit=new_month_money_limit,
	week_money_limit=new_week_money_limit, day_money_limit=new_day_money_limit,
	login_time=new_login_time, huntgroup_name=new_huntgroup_name,
	simultaneous_use=new_simultaneous_use, port_limit=new_port_limit,
	session_timeout=new_session_timeout, idle_timeout=new_idle_timeout,
	no_pass=new_no_pass, no_acct=new_no_acct,
	allow_callback=new_allow_callback, other_params=new_other_params,
	allowed_servers=new_allowed_servers, blocked=new_blocked,
	framed_ip=new_framed_ip, framed_mask=new_framed_mask, up=new_up,
	down=new_down, ippool_name=new_ippool_name
	WHERE gid=old_gid AND activated=0 AND
	deposit=old_deposit AND credit=old_credit AND
	tos=old_tos AND do_with_tos=old_do_with_tos AND 
	direction=old_direction AND fixed=old_fixed AND 
	fixed_cost=old_fixed_cost AND activation_time=old_activation_time AND
	total_time_limit=old_total_time_limit AND month_time_limit=old_month_time_limit AND
	week_time_limit=old_week_time_limit AND day_time_limit=old_day_time_limit AND
	total_traffic_limit=old_total_traffic_limit AND month_traffic_limit=old_month_traffic_limit AND
	week_traffic_limit=old_week_traffic_limit AND day_traffic_limit=old_day_traffic_limit AND
	total_money_limit=old_total_money_limit AND month_money_limit=old_month_money_limit AND
	week_money_limit=old_week_money_limit AND day_money_limit=old_day_money_limit AND
	login_time=old_login_time AND huntgroup_name=old_huntgroup_name AND
	simultaneous_use=old_simultaneous_use AND port_limit=old_port_limit AND
	session_timeout=old_session_timeout AND idle_timeout=old_idle_timeout AND
	no_pass=old_no_pass AND no_acct=old_no_acct AND
	allow_callback=old_allow_callback AND other_params=old_other_params AND
	allowed_servers=old_allowed_servers AND blocked=old_blocked AND
	framed_ip=old_framed_ip AND framed_mask=old_framed_mask AND up=old_up AND
	down=old_down AND ippool_name=old_ippool_name;
	RETURN NEW;
END;
'  LANGUAGE plpgsql VOLATILE;

CREATE OR REPLACE FUNCTION sk_rad_group_del()
RETURNS trigger AS '
BEGIN
	INSERT INTO sk_system_conf (attribute, value) VALUES (''radiusd_restart'', ''1'');
	DELETE FROM sk_users WHERE sk_users.gid=OLD.gid;
	DELETE FROM sk_card_series WHERE sk_card_series.gid=OLD.gid;
	DELETE FROM sk_prices WHERE sk_prices.gid=OLD.gid;
	DELETE FROM sk_group_tracker WHERE sk_group_tracker.gid=OLD.gid;
	DELETE FROM sk_actions WHERE sk_actions.gid=OLD.gid;
	RETURN OLD;
END;
'  LANGUAGE plpgsql VOLATILE;

CREATE OR REPLACE FUNCTION sk_rad_price_tg()
RETURNS trigger AS '
BEGIN
	INSERT INTO sk_system_conf (attribute, value) VALUES (''radiusd_restart'', ''1'');
	IF (TG_OP = ''INSERT'') THEN
		RETURN NEW;
	ELSIF (TG_OP = ''UPDATE'') THEN
		RETURN NEW;
	ELSIF (TG_OP = ''DELETE'') THEN
		RETURN OLD;
	END IF;
END;
'  LANGUAGE plpgsql VOLATILE;

CREATE OR REPLACE FUNCTION sk_acc_upd()
RETURNS trigger AS '
DECLARE
    tmpval int8;
BEGIN
    SELECT value INTO tmpval FROM sk_system_conf WHERE attribute=''internal_account_update'';
    IF (tmpval = 1) THEN
	RETURN OLD;
    END IF;
    UPDATE sk_users SET deposit=deposit+(NEW.a_sum-OLD.a_sum) WHERE sk_users.account_id=NEW.account_id;
    UPDATE sk_users SET expired=to_timestamp(sk_users.activation_time + extract(epoch from CURRENT_TIMESTAMP)) WHERE sk_users.activation_time > 0 AND sk_users.blocked=0 AND sk_users.account_id=NEW.account_id;
    RETURN NEW;
END;
' LANGUAGE plpgsql VOLATILE;

CREATE TRIGGER sk_rad_price_trigger AFTER INSERT OR UPDATE OR DELETE ON sk_prices FOR EACH ROW EXECUTE PROCEDURE sk_rad_price_tg();

CREATE TRIGGER sk_card_serie_del AFTER DELETE ON sk_card_series FOR EACH ROW EXECUTE PROCEDURE sk_card_serie_del();

CREATE TRIGGER sk_rad_user_add_tg BEFORE INSERT ON sk_users FOR EACH ROW EXECUTE PROCEDURE sk_rad_user_add();

CREATE TRIGGER sk_rad_user_upd_tg BEFORE UPDATE ON sk_users FOR EACH ROW EXECUTE PROCEDURE sk_rad_user_upd();

CREATE TRIGGER sk_rad_user_del_tg BEFORE DELETE ON sk_users FOR EACH ROW EXECUTE PROCEDURE sk_rad_user_del();

CREATE TRIGGER sk_rad_group_add_tg AFTER INSERT ON sk_packets FOR EACH ROW EXECUTE PROCEDURE sk_rad_group_add();

CREATE TRIGGER sk_rad_group_upd_tg AFTER UPDATE ON sk_packets FOR EACH ROW EXECUTE PROCEDURE sk_rad_group_upd();

CREATE TRIGGER sk_rad_group_del_tg AFTER DELETE ON sk_packets FOR EACH ROW EXECUTE PROCEDURE sk_rad_group_del();

CREATE TRIGGER sk_acc_upd_tg AFTER UPDATE ON sk_accounts FOR EACH ROW EXECUTE PROCEDURE sk_acc_upd();

DROP TRIGGER IF EXISTS sk_service_set_del ON sk_service_set CASCADE;

CREATE OR REPLACE FUNCTION sk_srv_set_del()
RETURNS trigger AS '
BEGIN
	DELETE FROM sk_accounts WHERE sk_accounts.service_set_id=OLD.service_set_id;
	DELETE FROM sk_holidays WHERE sk_holidays.service_set_id=OLD.service_set_id;
	DELETE FROM sk_packets WHERE sk_packets.service_set_id=OLD.service_set_id;
	RETURN OLD;
END;
' LANGUAGE plpgsql VOLATILE;

CREATE TRIGGER sk_service_set_del BEFORE DELETE ON sk_service_set FOR EACH ROW EXECUTE PROCEDURE sk_srv_set_del();
