<?php
 require_once(dirname(__FILE__).'/../../base-lib.inc'); define('STR_RADM_QUERY_ERR', "Can not execute query"); class RADMaint extends SSXApp { var $rr; var $time_barrier = 15811200; var $parsedlog = '/var/log/radius/parsed.log'; var $radlog = '/var/log/radius/radius.log'; var $KILLPROG = ''; var $own_name = 'RADMaint'; var $msg; public function __construct() { parent::__construct(array('appname'=>'suite')); $this->msg = STR_RADM_QUERY_ERR; if ( isset($argv[0])) { $this->own_name = $argv[0]; if ( get_num_of_running_prog( $this->own_name) > 1) { $this->log( CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', "Another copy of program - is running. Exiting"); return false; } } $this->rr = $this->load_object_resource('rad.Restarter'); if ( !is_object($this->rr)) return false; if ( isset($this->config['RADIUS'])) { if ( isset($this->config['RADIUS']['LOG'])) $this->radlog = $this->config['RADIUS']['LOG']; if ( isset($this->config['RADIUS']['PARSEDLOG'])) $this->parsedlog = $this->config['RADIUS']['PARSEDLOG']; if ( isset($this->config['RADIUS']['KILLPROG'])) $this->KILLPROG = $this->config['RADIUS']['KILLPROG']; if ( isset($this->config['RADIUS']['STORAGE_TIME'])) $this->time_barrier = $this->config['RADIUS']['STORAGE_TIME']; } return $this; } public function delete_restart_flag_from_db() { if( !$this->rr->db->clean_flag()) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'Remove RADIUS restart flag from database'); return true; } public function check_restart_flag_in_db() { return $this->rr->db->get_flag(); } public function check_norestart_flag_in_db() { $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'Check no_restart flag for RADIUS'); $sth = $this->db->GetAll("SELECT COUNT(*) FROM sk_system_conf WHERE attribute='radiusd_no_restart'"); if ( !is_array($sth)) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } return ($sth[0][0]>0); } public function check() { $pid = 0; if(($pid = get_pid_of('radiusd')) == 0) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, '', "Radiusd has not executed"); if ( $this->check_norestart_flag_in_db()) { $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', "Trying to restart RADIUSD."); exec_event_exec('/etc/init.d/radiusd restart'); return true; } else { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, '', "NO_RESTART_FLAG is set or other error."); return false; } } if ( !$this->check_restart_flag_in_db()) { $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'RADIUS restart flag is not set'); return true; } $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'Send HUP-signal to RADIUS'); $this->rr->restart(); $this->delete_restart_flag_from_db(); return true; } public function freq() { $sth = array(); $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'Close staled sessions'); if ( !$this->db->Execute("UPDATE sk_actions SET stop_time=start_time+time_on*interval '1s', terminate_cause='Idle-Timeout' WHERE terminate_cause='Online' AND extract(epoch from CURRENT_TIMESTAMP)-last_change>=300")) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } if ( empty($this->KILLPROG)) return true; $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'Try to close session for barbarians'); if( !($sth = $this->db->GetAll( "SELECT sk_actions.username, sk_actions.server, sk_actions.client_ip, sk_actions.port, sk_actions.ip FROM sk_actions,sk_users WHERE sk_actions.terminate_cause='Online' AND sk_users.deposit+sk_users.credit<0 AND sk_actions.username = sk_users.username"))) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } for ( $i = 0; $i < count($sth); $i ++) { $this->log( CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', sprintf("Trying to close session for user: ", $sth[$i][0])); $str = $this->KILLPROG ." ". $sth[$i][0] ." ". $sth[$i][1] ." ". $sth[$i][2] . " " . $sth[$i][3] . " " . $sth[$i][4]; mvexec($str); } return true; } private function remove_money() { if( !$this->db->Execute( "UPDATE sk_users SET deposit=0 WHERE deposit > 0 AND extract(epoch from expired) > 0 AND extract(epoch from expired) < extract(epoch from CURRENT_TIMESTAMP)")) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } return true; } private function bill_daily() { if( !$this->db->Execute( "UPDATE sk_users SET deposit=deposit-fixed_cost WHERE deposit > 0 AND tos = 0 AND fixed_cost > 0 AND fixed = 2 AND blocked = 0 AND activated > 0")) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } if( !$this->db->Execute( "UPDATE sk_users SET expired=CURRENT_TIMESTAMP WHERE deposit <= 0 AND tos = 0 AND fixed_cost > 0 AND fixed = 2 AND blocked = 0 AND activated > 0 AND extract(epoch from last_connection) > 0")) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } $arr = $this->db->GetAll("SELECT fixed_cost, gid FROM sk_packets WHERE tos = 0 AND fixed = 2 AND fixed_cost > 0 AND blocked = 0 AND activated > 0"); for ($i = 0; $i < count($arr); $i ++) { if( !$this->db->Execute( "UPDATE sk_users SET deposit=deposit-".$arr[$i]['fixed_cost']." WHERE deposit > 0 AND gid = ".$arr[$i]['gid']." AND tos = 0 AND fixed_cost = 0 AND fixed = 0 AND blocked = 0 AND activated > 0")) $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); if( !$this->db->Execute( "UPDATE sk_users SET expired=CURRENT_TIMESTAMP WHERE deposit <= 0 AND gid = ".$arr[$i]['gid']." AND tos = 0 AND fixed_cost = 0 AND fixed = 0 AND blocked = 0 AND activated > 0 AND extract(epoch from last_connection) > 0")) $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); } } public function daily() { if( !$this->db->Execute( "DELETE FROM sk_actions WHERE extract(epoch from stop_time)<=extract(epoch from CURRENT_TIMESTAMP)-".$this->time_barrier)) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } if( !$this->db->Execute( "DELETE FROM sk_users WHERE extract(epoch from expired)>0 AND extract(epoch from expired)<=extract(epoch from CURRENT_TIMESTAMP)-".$this->time_barrier)) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } if( !$this->db->Execute( "DELETE FROM sk_users WHERE deposit >= 0 AND extract(epoch from last_connection)>0 AND extract(epoch from last_connection)<=extract(epoch from CURRENT_TIMESTAMP)-".$this->time_barrier)) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } if( !$this->db->Execute( "DELETE FROM sk_card_series WHERE cards_col<=0")) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } $this->remove_money(); $this->bill_daily(); if( !$this->db->Execute( "DELETE FROM sk_radlog WHERE extract(epoch from CURRENT_TIMESTAMP)-extract(epoch from insertion_time)>2592000")) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } if( !$this->db->Execute( "VACUUM ANALYZE")) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), $this->msg); return false; } $this->db->reindex(); return true; } public function hourly() { return $this->remove_money(); } public function parse_freerad_log() { $datetime = ''; $msg = ''; $query = ''; $this->log( CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'Start parsing of RADIUS log file'); if ( !file_exists($this->radlog)) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, '', sprintf("Radius log file (%s) does not exist!", $this->radlog)); return true; } if ( file_exists( $this->parsedlog)) unlink( $this->parsedlog); rename( $this->radlog, $this->parsedlog); touch($this->radlog); chmod($this->radlog, 0666); $handle = fopen( $this->parsedlog, "r"); if ( $handle <= 0) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, '', "Can not open RADIUS log file!"); return false; } while(!feof($handle)) { $str = fgets($handle); if ( !$str) break; $str = trim($str); $str = preg_replace('/[()]/', '', $str); $larr = explode(' : ', $str); $datetime = $larr[0]; $msg = $larr[1]; $msg = str_replace("'", '"', $msg); $query = sprintf("insert into sk_radlog (rad_time, rad_msg, insertion_time) values('%s','%s', CURRENT_TIMESTAMP)", $datetime,$msg); if ( ! $this->db->Execute($query)) { $this->log(CMMN_ERROR, $this->own_name, __FILE__, __LINE__, $this->db->errorMsg(), sprintf("Can not prepare \"%s\". SQL error: ", $query)); return false; } } fclose( $handle); $this->log(CMMN_INFO, $this->own_name, __FILE__, __LINE__, '', 'RADIUS log file parsed ok'); return true; } } ?>
